      SUBROUTINE INITWI(IBUGIN)
C
C     PURPOSE--THIS IS SUBROUTING INITWI.
C              (THE   WI    AT THE END OF    INITWI   STANDS FOR    WINDOW SYSTE
C              THIS SUBROUTINE INITIALIZES WINDOW SYSTEM VARIABLES AND PARAMETER
C     NOTE--
C           IBUGWI = BUG SWITCH FOR WINDOWS
C           ISUBWI = SUBROUTINE TRACE SWITCH FOR WINDOWS
C           IERRWI = ERROR SWITCH FOR WINDOWS
C
C           IDEFWS = DEFAULT WINDOW SYSTEM
C           IWINSY = WINDOW SYSTEM
C           IDEFWP = DEFAULT WINDOW POINTER
C           IWINPO = WINDOW POINTER
C
C           IWERIN    = ERASE WHEN INITIALIZE THE WINDOW SYSTEM?
C
C           MAXWIN    = MAXIMUM NUMBER OF WINDOWS
C           IWINCW    = CURRENT WINDOW
C           IWEROP(I) = ERASE WHEN OPEN A WINDOW?
C           IWINBC(I) = BACKGROUND COLOR FOR A WINDOW
C           IWINFC(I) = FOREGROUND COLOR FOR A WINDOW
C           IWINTY(I) = TYPE OF WINDOW (POP/PERM)
C           IWINFR(I) = FRAME FOR A WINDOW?
C           IWINWR(I) = WRAP/NO WRAP WITHIN A WINDOW?
C           IWINX1(I) = UPPER LEFT  CORNER X VALUE FOR WINDOW
C           IWINY1(I) = UPPER LEFT  CORNER Y VALUE FOR WINDOW
C           IWINXL(I) = HORIZONTAL LENGTH FOR THE WINDOW
C           IWINYL(I) = VERTICAL   LENGTH FOR THE WINDOW
C           IWINX2(I) = LOWER RIGHT CORNER X VALUE FOR WINDOW
C           IWINY2(I) = LOWER RIGHT CORNER Y VALUE FOR WINDOW
C           IWERCL(I) = ERASE WHEN CLOSE A WINDOW?
C           IWWRPR(I) = WRITE PREVIOUS SCREEN AFTER CLOSE WINDOW?
C
C           IWEREX    = ERASE WHEN EXIT THE WINDOW SYSTEM?
C
C     WRITTEN BY--JAMES J. FILLIBEN
C                 STATISTICAL ENGINEERING DIVISION
C                 CENTER FOR APPLIED MATHEMATICS
C                 NATIONAL BUREAU OF STANDARDS
C                 WASHINGTON, D. C. 20234
C                 PHONE--301-975-2855
C     NOTE--DATAPLOT IS A REGISTERED TRADEMARK
C           OF THE NATIONAL BUREAU OF STANDARDS.
C     LANGUAGE--ANSI FORTRAN (1977)
C     VERSION NUMBER--90.9
C     ORIGINAL VERSION--SEPTEMBER 1990.
C     UPDATED         --NOVEMBER  1990.  IWINSY FROM OTG TO NONE
C     UPDATED         --JANUARY   1991.  IWINSY FROM NONE TO C
C     UPDATED         --AUGUST    1993.  COMPILE ERROR (RS-6000)
C
C-----NON-COMMON VARIABLES----------------------------------
C
      CHARACTER*4 IBUGIN
CCCCC AUGUST 1993.  COMPILE ERROR ON RS-6000, ADD FOLLOWING LINE
      CHARACTER*4 IWINPO
C
C-----COMMON (FOR WINDOW SYSTEM)----------------------------
C
      INCLUDE 'DPCOWI.INC'
C
C-----COMMON VARIABLES (GENERAL)----------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
      IF(IBUGIN.EQ.'OFF')GOTO99
      WRITE(ICOUT,90)
   90 FORMAT(1X)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,95)
   95 FORMAT('***** AT THE BEGINNING OF INITWI--')
      CALL DPWRST('XXX','BUG ')
   99 CONTINUE
C
      IBUGWI='OFF'
      ISUBWI='XXXX'
      IERRWI='NO'
C
      IDEFWS='NONE'
CCCCC THE FOLLOWING LINE WAS CHANGED NOVEMBER 1990
CCCCC IWINSY='OTG'
CCCCC THE FOLLOWING LINE WAS FIXED JANUARY 1991
CCCCC IWINSY='NONE'
CCCCC IWINSY='C'
CCCCC THE FOLLOWING LINE WAS FIXED MAY 1991
      IWINSY='NONE'
      IDEFWP='NUMB'
      IWINPO='NUMB'
C
      MAXWIN=10
      IWINCW=0
C
      IWERIN='OFF'
C
      DO1000I=1,10
      IWEROP(I)='OFF'
      IWINBC(I)='BLUE'
      IWINFC(I)='WHIT'
      WIPOP(I)='POP'
      IWINTY(I)='POP'
      IWINFR(I)='OFF'
      IWINWR(I)='OFF'
      IWINX1(I)=1
      IWINY1(I)=1
      IWINXL(I)=80
      IWINYL(I)=24
      IWINX2(I)=80
      IWINY2(I)=24
      IWERCL(I)='OFF'
      IWWRPR(I)='OFF'
 1000 CONTINUE
C
      IWEREX='OFF'
C
C               *******************************
C               **  EXIT AND RETURN TO MAIN  **
C               *******************************
C
 9000 CONTINUE
      IF(IBUGIN.EQ.'OFF')GOTO9999
      WRITE(ICOUT,9990)
 9990 FORMAT(1X)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,9995)
 9995 FORMAT('***** AT THE END       OF INITWI--')
      CALL DPWRST('XXX','BUG ')
 9999 CONTINUE
C
      RETURN
      END
      SUBROUTINE DPWIPO(IHARG,NUMARG,IDEFWP,IWINPO,
     1IBUGP2,IFOUND,IERROR)
C
C     PURPOSE--DEFINE THE WINDOW POINTER
C              THE WINDOW POINTER WILL BE PLACED
C              IN THE HOLLERITH VARIABLE IWINPO.
C     INPUT  ARGUMENTS--IHARG  (A  HOLLERITH VECTOR)
C                     --NUMARG
C                     --IDEFWP
C     OUTPUT ARGUMENTS--IWINPO
C                     --IFOUND ('YES' OR 'NO' )
C                     --IERROR ('YES' OR 'NO' )
C     WRITTEN BY--JAMES J. FILLIBEN
C                 STATISTICAL ENGINEERING DIVISION
C                 INFORMATION TECHNOLOGY LABORATORY
C                 NATIONAL INSTITUTE OF STANDARDS AND TECHNOLOGY
C                 GAITHERSBURG, MD 20899-8980
C                 PHONE--301-975-2899
C     NOTE--DATAPLOT IS A REGISTERED TRADEMARK
C           OF THE NATIONAL INSTITUTE OF STANDARDS AND TECHNOLOGY.
C     LANGUAGE--ANSI FORTRAN (1977)
C     VERSION NUMBER--90/9
C     ORIGINAL VERSION--AUGUST 1990.
C
C-----CHARACTER STATEMENTS FOR NON-COMMON VARIABLES-------------------
C
      CHARACTER*4 IHARG
      CHARACTER*4 IDEFWP
      CHARACTER*4 IWINPO
C
      CHARACTER*4 IBUGP2
      CHARACTER*4 IFOUND
      CHARACTER*4 IERROR
C
C---------------------------------------------------------------------
C
      DIMENSION IHARG(*)
C
C---------------------------------------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
      IFOUND='NO'
      IERROR='NO'
C
      IF(NUMARG.EQ.0)GOTO1199
      IF(NUMARG.EQ.1)GOTO1150
      IF(NUMARG.GE.2)GOTO1110
      GOTO1199
C
 1110 CONTINUE
      IF(IHARG(NUMARG).EQ.'ON')GOTO1150
      IF(IHARG(NUMARG).EQ.'OFF')GOTO1150
      IF(IHARG(NUMARG).EQ.'AUTO')GOTO1150
      IF(IHARG(NUMARG).EQ.'DEFA')GOTO1150
      GOTO1160
C
 1150 CONTINUE
      IWINPO=IDEFWP
      GOTO1180
C
 1160 CONTINUE
      IWINPO=IHARG(NUMARG)
      GOTO1180
C
 1180 CONTINUE
      IFOUND='YES'
C
      IF(IFEEDB.EQ.'OFF')GOTO1189
      WRITE(ICOUT,999)
  999 FORMAT(1X)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,1181)IWINPO
 1181 FORMAT('THE WINDOW POINTER HAS JUST BEEN SET TO ',
     1A4)
      CALL DPWRST('XXX','BUG ')
 1189 CONTINUE
      GOTO1199
C
 1199 CONTINUE
      RETURN
      END
      SUBROUTINE DPWISY(IHARG,NUMARG,IDEFWS,IWINSY,
     1IBUGP2,IFOUND,IERROR)
C
C     PURPOSE--DEFINE THE WINDOW SYSTEM
C              THE WINDOW MANAGER WILL BE PLACED
C              IN THE HOLLERITH VARIABLE IWINSY.
C     INPUT  ARGUMENTS--IHARG  (A  HOLLERITH VECTOR)
C                     --NUMARG
C                     --IDEFWS
C     OUTPUT ARGUMENTS--IWINSY
C                     --IFOUND ('YES' OR 'NO' )
C                     --IERROR ('YES' OR 'NO' )
C     WRITTEN BY--JAMES J. FILLIBEN
C                 STATISTICAL ENGINEERING DIVISION
C                 INFORMATION TECHNOLOGY LABORATORY
C                 NATIONAL INSTITUTE OF STANDARDS AND TECHNOLOGY
C                 GAITHERSBURG, MD 20899-8980
C                 PHONE--301-975-2899
C     NOTE--DATAPLOT IS A REGISTERED TRADEMARK
C           OF THE NATIONAL INSTITUTE OF STANDARDS AND TECHNOLOGY.
C     LANGUAGE--ANSI FORTRAN (1977)
C     VERSION NUMBER--90/9
C     ORIGINAL VERSION--AUGUST 1990.
C
C-----CHARACTER STATEMENTS FOR NON-COMMON VARIABLES-------------------
C
      CHARACTER*4 IHARG
      CHARACTER*4 IDEFWS
      CHARACTER*4 IWINSY
C
      CHARACTER*4 IBUGP2
      CHARACTER*4 IFOUND
      CHARACTER*4 IERROR
C
C---------------------------------------------------------------------
C
      DIMENSION IHARG(*)
C
C---------------------------------------------------------------------
C
      CHARACTER*4 IFEEDB
      CHARACTER*4 IPRINT
      CHARACTER*240 ICOUT
C
      COMMON /MACH/IRD,IPR,CPUMIN,CPUMAX,NUMBPC,NUMCPW,NUMBPW
      COMMON /PRINT/IFEEDB,IPRINT
      COMMON /TEXTOU/ICOUT,NCOUT,ILOUT
C
C-----START POINT-----------------------------------------------------
C
      IFOUND='NO'
      IERROR='NO'
C
      IF(NUMARG.EQ.0)GOTO1199
      IF(NUMARG.EQ.1)GOTO1150
      IF(NUMARG.GE.2)GOTO1110
      GOTO1199
C
 1110 CONTINUE
      IF(IHARG(NUMARG).EQ.'ON')GOTO1150
      IF(IHARG(NUMARG).EQ.'OFF')GOTO1150
      IF(IHARG(NUMARG).EQ.'AUTO')GOTO1150
      IF(IHARG(NUMARG).EQ.'DEFA')GOTO1150
      GOTO1160
C
 1150 CONTINUE
      IWINSY=IDEFWS
      GOTO1180
C
 1160 CONTINUE
      IWINSY=IHARG(NUMARG)
      GOTO1180
C
 1180 CONTINUE
      IFOUND='YES'
C
      IF(IFEEDB.EQ.'OFF')GOTO1189
      WRITE(ICOUT,999)
  999 FORMAT(1X)
      CALL DPWRST('XXX','BUG ')
      WRITE(ICOUT,1181)IWINSY
 1181 FORMAT('THE WINDOW SYSTEM HAS JUST BEEN SET TO ',
     1A4)
      CALL DPWRST('XXX','BUG ')
 1189 CONTINUE
      GOTO1199
C
 1199 CONTINUE
      RETURN
      END
